<?php
include "restutils.php";

class EmployeeDetail {
	/**
	 * Retrieve employee details for a particular person
	 * @success 200 employee details 
	 * @error 400 Incorrect configuration of imageURL or employee directory
	 * @format text/json
	 * @example
	 * {
	 * 	  "photourl":"http://...1234.jpg",
	 *    "responsibility":"Overseer"
	 * }
	 *
	 */
    function onRetrieve() {
    	$imageURLbase = zget('/config/external/person/imageurl', null);
    	if ($imageURLbase == null) {
    		zput('/request/status', 400);
    		echo "Image URL not configured";
    		return;
    	}
        $email = zget('/request/params/employeedetailId');
        $empDirectoryUrl = zget('/config/external/person/detailurl', null);
        if ($empDirectoryUrl == null) {
            zput('/request/status', 400);
        	echo "Employee directory URL not configured";
            return;
        }
        $response = connection_get($empDirectoryUrl.$email, array());
        if ($response == null) {
            zput('/request/status', 400);
        	echo "Employee directory not accessible";
            return;
        }
        // the data is returned as a set of properties
        $properties = property_decode($response['body']);
        if (array_key_exists('CNUM', $properties)) {
     	   $cnum = ltrim($properties['CNUM']);
        	$details = array('photourl'=>$imageURLbase.$cnum.'.jpg', 'responsibility' => $properties['JOBRESPONSIB']);
      	    /** Takes too much time !
        	$bluegroupsurl= "http://w4.ibm.com/bluepages/json/groups?id=".$email;
        	$response = connection_get($bluegroupsurl, array());
       	 	$groups = json_decode($response['body']);
        	$details['bluegroups'] = $groups;
        	**/
        	zput('/request/headers/out/Content-Type', 'text/json');
        	echo json_encode($details);
        } else {
        	put('/request/status', 400);
        	echo "Employee information not available";
        }
    }  
    
}