import zero.core.connection.Connection
import zero.json.Json
import zero.kernel.context.GlobalContextURIs.Config
import java.util.GregorianCalendar
import java.util.Calendar
import java.text.SimpleDateFormat


def contact = "http://localhost:"+zget("/config/http/port") + zget("/config/contextRoot")+"/resources/contact"


System.out.println ("Using $contact")

def addAbs (contact, abs)
{
	Connection conn = new Connection(contact, Connection.Operation.POST);
	def data = [:]

	data.day = "day"
	data.reason = abs.reason
	data.startdate = abs.startdate
	data.email = abs.email
	data.tod = abs.tod
	if (abs.detail!=null) {
		data.details = abs.detail.trim()
	}
	def d = Json.encode(data)
	System.out.println ("$d")
	conn.addRequestHeader("Content-Type", "text/json; charset=\"UTF-8\"");
//	 Set request body (requestData is a Map representing the JSON object)
	conn.setRequestBody(d); 
//	 Send request and prepare for response
	Connection.Response resp = conn.getResponse();
	 if (!"200".equals(resp.getResponseStatus())) {
		 System.out.println ("$resp unsuccessful") 
	} 
}

SimpleDateFormat sd = new SimpleDateFormat ("yyyy-MM-dd")
try {
	new File(zget(Config.root)+'/app/tasks/absence.csv').newReader('UTF-8').splitEachLine(',') {fields ->
		Calendar cal = new GregorianCalendar()
		int add = Integer.parseInt(fields[2].trim());		
		cal.add (Calendar.DATE, add)		
		addAbs (contact, [email:fields[0].trim(), reason: fields[1].trim(), startdate:sd.format (cal.getTime()), tod: fields[3].trim(), detail: fields[4]])
}
} catch (java.net.ConnectException e) {
	System.out.println ("Server is not available. Run 'zero start'")
}
