dojo.provide("mystore");

dojo.declare(
    "mystore",
	null,
	{
		userTemplate :[ ["",""], [[0],[0]], [[0],[0]],[[0],[0]],[[0],[0]],[[0],[0]]],
		/**
		 * 
		 * @param {Object} params
		 */
		constructor: function (params) {			
			dojo.mixin(this, {
				"data":[],
				"datamap":{},
				"userno": 0,
				"daymap": {}, // INPUT // "mm/dd/yyyy" :1, .... :6 week days.
				"statemap": {} // INPUT // 0 - office 1 - wah ... etc.
			});
			dojo.mixin(this, params);		
		},
		/**
		 * loads data and reformats it.
		 * @param {Object} data
		 */
		load: function (data){
			var userno = 0;
			for (var i in data)
			{				 
				var email = data[i].email;
				var user = this.datamap[email]; 
				if (!user) {
					user = dojo.clone (this.userTemplate);
					user[0][0] = data[i].name; 
					user[0][1] = data[i].home_phone;
					user[6] = data[i].email;
					this.datamap[email] = user;
					this.data[this.userno] = user;
					user.userno = this.userno;
					this.userno++;
				}
				
				if (data[i].reason) { // out of office, extract data
					var dt = data[i].date;
					var day = this.daymap[dt];
					if (dt && day) {
						var ammsg = data[i].details.AM;
						var pmmsg = data[i].details.PM;
						if (ammsg) {
							var idx = ammsg.indexOf('\n');
							if (idx > -1) {
								ammsg = ammsg.slice(idx + 1);
							}
							else {
								ammsg = "";
							}
						}
						if (pmmsg) {
							var idx = pmmsg.indexOf('\n');
							if (idx > -1) {
								pmmsg = pmmsg.slice(idx + 1);
							}
							else {
								pmmsg = "";
							}
						}
						if (data[i].reason.AM) { // else assumed an all day event.
							user[day][0] = [this.statemap[data[i].reason.AM], ammsg]; // map text to number
							user[7] = true;
						}
						
						if (data[i].reason.PM) { // else assumed an all day event.
							user[day][1] = [this.statemap[data[i].reason.PM], pmmsg]; // map text to number
							user[7] = true;
						}
					} else {
						console.warn("dt=" + dt + ", day=" + day + ", data[" + i + "]=" + data[i]+", "+this.daymap);
					}
				}
			}
		}		
	}
);